//+------------------------------------------------------------------+
//|                                        Perevertysh20240512-1.mq5 |
//|                                                          Voronin |
//|                                      Virtual Trailing Stop 2.mq5 |
//|                              Copyright © 2020, Vladimir Karputov |
//|                     https://www.mql5.com/ru/market/product/43516 |
//|                                           http://wmua.ru/slesar/ |
//|                                                           Gerbut |
//|                                           andriygerbut@gmail.com |
//+------------------------------------------------------------------+
#property version   "1.00"
#property version   "1.000"
#property strict

// Libraries:
//+------------------------------------------------------------------+
#include <Trade\Trade.mqh>
#include <Trade\SymbolInfo.mqh>
#include <Trade\PositionInfo.mqh>
//#include <SecAuxLib.mqh>
#include <MT4Orders.mqh>

CPositionInfo     k_pos;
CSymbolInfo       m_symbol;
CTrade            m_trade;

//+------------------------------------------------------------------+
// Input parameters:
//+------------------------------------------------------------------+
enum ENUM_SYMBOL
{
    EURUSD  = 0,
    GPBUSD  = 1,
    USDCHF  = 2,
    BTCUSD  = 3,
    USDCAD  = 4,
    AUDCAD  = 5,
    NAZUSD  = 6,
    AUDCHF  = 7,
    AUDJPY  = 8,
    AUDUSD  = 9,
    BITCOIN = 10,
    XAUUSD  = 11,
    XAGUSD  = 12
};
input ENUM_SYMBOL     SYMBOL;
input ENUM_TIMEFRAMES TimeFrame       = PERIOD_CURRENT;
input double          LotSize         = 0.01; 
input ulong           Magic_m         = 9191;        // M1-9991,H1-9960,H4-9240,D2-1440,perevertysh-9191
input ulong           InpDeviation    = 10;          // Deviation, in points (1.00045-1.00055=10 points)
//+------------------------------------------------------------------+
double   SymbolPoint                  = SymbolInfoDouble(Symbol(),SYMBOL_POINT); // значение пункта цены
double   ask                          = NormalizeDouble(SymbolInfoDouble(Symbol(), SYMBOL_ASK),_Digits);
double   bid                          = NormalizeDouble(SymbolInfoDouble(Symbol(), SYMBOL_BID),_Digits);
double   spred                        = NormalizeDouble(SymbolInfoInteger(Symbol(),SYMBOL_SPREAD),_Digits);
//double   PerSpread                    = ((ask - bid) / ask) * 100;                          // Процент спреда
//double   PerVolatiliti                = SymbolInfoDouble(Symbol(),SYMBOL_PRICE_VOLATILITY); // Процент волатильности - не работает в mql5!
double   Tick_Size                    = SymbolInfoDouble(Symbol(),SYMBOL_TRADE_TICK_SIZE); // минимально возможное изменение цены
ulong    m_position_ticket            = 0;
ulong    ClosedTicket                 = 0;
MqlTradeRequest m_request;                            // структура торгового запроса
MqlTradeResult m_result;                              // структура результата торгового запроса
double   m_adjusted_point;                            // point value adjusted for 3 or 5 points
ulong    MS                           = 1000;
ulong    TFMS                         = PeriodSeconds(/*Period()*/ PERIOD_M1) * MS;

//+------------------------------------------------------------------+
// Methods-Events:                                                   |
//+------------------------------------------------------------------+
int OnInit()
{
   m_trade.SetExpertMagicNumber(Magic_m);
   if(!m_symbol.Name(Symbol()))                                                 // sets symbol name
     {
      Print(__FILE__," ",__FUNCTION__,", ERROR: CSymbolInfo.Name");
      return(INIT_FAILED);
     }
   RefreshRates();
//---
   m_trade.SetMarginMode();
   m_trade.SetTypeFillingBySymbol(m_symbol.Name());
   m_trade.SetDeviationInPoints(InpDeviation);

   m_adjusted_point             = SymbolPoint;                                     //m_symbol.Point()*digits_adjust;
//---
        EventSetMillisecondTimer(300);
        return (INIT_SUCCEEDED);
}
    
void OnTick()
{
   OnTimer();
}

void OnTimer()
{
   /*int         total            = PositionsTotal();
   for(int i=total-2; i>=0; i--)
   {
      k_pos.SelectByIndex(i);
      mposition_ticket = PositionGetTicket(i);
      string m_position_symbol       = k_pos.Symbol();
      long   m_position_magic        = k_pos.Magic();
      Print("total = ",(string)total,", mposition_ticket = ",(string)mposition_ticket,", m_position_magic = ",(string)m_position_magic);*/
        MqlTradeRequest tradeRequest = { };
        MqlTick last_tick;
        MqlTick current_tick;
        SymbolInfoTick(Symbol(),last_tick);
        SymbolInfoTick(Symbol(),current_tick);
        double ask0             = current_tick.ask;                               //SymbolInfoDouble(Symbol(), SYMBOL_ASK);
        double bid0             = current_tick.bid;
        ulong  time0            = current_tick.time_msc;
        ulong  timeOpen         = PositionGetInteger(POSITION_TIME_MSC);
        ENUM_POSITION_TYPE Type = (ENUM_POSITION_TYPE)PositionGetInteger(POSITION_TYPE); // тип позиции
        double Price            = PositionGetDouble(POSITION_PRICE_OPEN);
        double Tp               = PositionGetDouble(POSITION_TP);
        m_position_ticket       = PositionGetInteger(POSITION_TICKET);
        double lt               = PositionGetDouble(POSITION_VOLUME); // объем позиции
        ulong  magic            = PositionGetInteger(POSITION_MAGIC); // MagicNumber позиции
double VolatilitiUp1            = 0;
double VolatilitiUp2            = 0;
double VolatilitiUp3            = 0;
double VolatilitiUp4            = 0;
double VolatilitiUp5            = 0;
double VolatilitiUp6            = 0;
double VolatilitiLow1           = 0;
double VolatilitiLow2           = 0;
double VolatilitiLow3           = 0;
double VolatilitiLow4           = 0;
double VolatilitiLow5           = 0;
double VolatilitiLow6           = 0;
double Volatiliti               = 0;
double ask1                     = 0;
double ask2                     = 0;
double ask3                     = 0;
double ask4                     = 0;
double ask5                     = 0;
double ask6                     = 0;
double bid1                     = 0;
double bid2                     = 0;
double bid3                     = 0;
double bid4                     = 0;
double bid5                     = 0;
double bid6                     = 0;
double   PriceArr[]; // Создание массива цен
ArraySetAsSeries(PriceArr, true); // Сортировка данных
int      ATRDef                 = iATR(_Symbol,_Period,6); // определение ATR
CopyBuffer(ATRDef,0,0,3,PriceArr); // определяем данные и сохраняем результат
double   ATRValue               = NormalizeDouble(PriceArr[0],_Digits); // Получаем значения текущих данных
MqlTick ticks[];
MqlTick tick;
SymbolInfoTick(Symbol(),tick);
  MqlTick mqlTick1[], symbTick1; // объявили переменные
  SymbolInfoTick(_Symbol, symbTick1); // это последний тик
  int copied1 = CopyTicksRange(_Symbol, mqlTick1, COPY_TICKS_INFO, symbTick1.time_msc, symbTick1.time_msc-10000); // цены за последние 10 секунд
  double bid_arr1[];
  ArrayResize(bid_arr1,copied1,100000);
  double ask_arr1[];
  ArrayResize(ask_arr1,copied1,100000);
  for(int i = 0; i < copied1; i++)
  {
            bid_arr1[i] = mqlTick1[i].bid;
            ask_arr1[i] = mqlTick1[i].ask;
            bid1        = NormalizeDouble(bid_arr1[0], _Digits); // первая цена bid за последние 10 секунд (аналог открытия текущего или закрытия предыдущего периода)
            ask1        = NormalizeDouble(ask_arr1[0], _Digits); // первая цена ask за последние 10 секунд (аналог открытия текущего или закрытия предыдущего периода)
     int    IndMaxBid   = ArrayMaximum(bid_arr1, 0, ArraySize(bid_arr1)-1);      // Индекс элемента массива bid_arr1 с максимальной ценой
     double highestBid  = bid_arr1[IndMaxBid];                      // Самая высокая цена bid за последние 10 секунд
     int    IndMinBid   = ArrayMinimum(bid_arr1, 0, ArraySize(bid_arr1)-1);      // Индекс элемента массива bid_arr1 с минимальной ценой
     double lowestBid   = bid_arr1[IndMinBid];                      // Самая низкая цена bid за последние 10 секунд
     int    IndMaxAsk   = ArrayMaximum(ask_arr1, 0, ArraySize(ask_arr1)-1);      // Индекс элемента массива ask_arr1 с максимальной ценой
     double highestAsk  = ask_arr1[IndMaxAsk];                      // Самая высокая цена ask за последние 10 секунд
     int    IndMinAsk   = ArrayMinimum(ask_arr1, 0, ArraySize(ask_arr1)-1);      // Индекс элемента массива ask_arr1 с минимальной ценой
     double lowestAsk   = ask_arr1[IndMinAsk];                      // Самая низкая цена ask за последние 10 секунд
     double highestHigh = (highestBid+highestAsk)/2;               // Средняя наибольшего ask и наибольшего bid элемента
     double lowestLow   = (lowestBid+lowestAsk)/2;                 // Средняя наименьшего ask и наименьшего bid элемента
     if(highestHigh - (ask0 + bid0 + bid1 + ask1)/4 >= (ask0 + bid0 + bid1 + ask1)/4 - lowestLow)
     {
        VolatilitiUp1 = highestHigh - (ask0 + bid0 + bid1 + ask1)/4;
        VolatilitiLow1 = 0;
     }
     else if(highestHigh - (ask0 + bid0 + bid1 + ask1)/4 < (ask0 + bid0 + bid1 + ask1)/4 - lowestLow)
     {
        VolatilitiLow1 = (ask0 + bid0 + bid1 + ask1)/4 - lowestLow;
        VolatilitiUp1 = 0;
     }
  }
  MqlTick mqlTick2[], symbTick2; // объявили переменные
  SymbolInfoTick(_Symbol, symbTick2); // это последний тик
  int copied2 = CopyTicksRange(_Symbol, mqlTick2, COPY_TICKS_INFO, symbTick2.time_msc-10000, symbTick2.time_msc-20000); // цены между 10 секунд и 20 секунд назад
  double bid_arr2[];
  ArrayResize(bid_arr2,copied2,100000);
  double ask_arr2[];
  ArrayResize(ask_arr2,copied2,100000);
  for(int i = 0; i < copied2; i++)
  {
            bid_arr2[i] = mqlTick2[i].bid;
            ask_arr2[i] = mqlTick2[i].ask;
            bid2        = NormalizeDouble(bid_arr2[0], _Digits); // первая цена bid между 10 секунд и 20 секунд назад (аналог открытия текущего или закрытия предыдущего периода)
            ask2        = NormalizeDouble(ask_arr2[0], _Digits); // первая цена ask между 10 секунд и 20 секунд назад (аналог открытия текущего или закрытия предыдущего периода)
     int    IndMaxBid   = ArrayMaximum(bid_arr2, 0, ArraySize(bid_arr2)-1);      // Индекс элемента массива bid_arr2 с максимальной ценой
     double highestBid  = bid_arr2[IndMaxBid];                      // Самая высокая цена bid между 10 секунд и 20 секунд назад
     int    IndMinBid   = ArrayMinimum(bid_arr2, 0, ArraySize(bid_arr2)-1);      // Индекс элемента массива bid_arr2 с минимальной ценой
     double lowestBid   = bid_arr2[IndMinBid];                      // Самая низкая цена bid между 10 секунд и 20 секунд назад
     int    IndMaxAsk   = ArrayMaximum(ask_arr2, 0, ArraySize(ask_arr2)-1);      // Индекс элемента массива ask_arr2 с максимальной ценой
     double highestAsk  = ask_arr2[IndMaxAsk];                      // Самая высокая цена ask между 10 секунд и 20 секунд назад
     int    IndMinAsk   = ArrayMinimum(ask_arr2, 0, ArraySize(ask_arr2)-1);      // Индекс элемента массива ask_arr2 с минимальной ценой
     double lowestAsk   = ask_arr2[IndMinAsk];                      // Самая низкая цена ask между 20 секунд и 20 секунд назад
     double highestHigh = (highestBid+highestAsk)/2;               // Средняя наибольшего ask и наибольшего bid элемента
     double lowestLow   = (lowestBid+lowestAsk)/2;                 // Средняя наименьшего ask и наименьшего bid элемента
     if(highestHigh - (ask1 + bid1 + bid2 + ask2)/4 >= (ask1 + bid1 + bid2 + ask2)/4)
     {
        VolatilitiUp2 = highestHigh - (ask1 + bid1 + bid2 + ask2)/4;
        VolatilitiLow2 = 0;
     }
     else if(highestHigh - (ask1 + bid1 + bid2 + ask2)/4 < (ask1 + bid1 + bid2 + ask2)/4 - lowestLow)
     {
        VolatilitiLow2 = (ask1 + bid1 + bid2 + ask2)/4 - lowestLow;
        VolatilitiUp2 = 0;
     }
  }
  MqlTick mqlTick3[], symbTick3; // объявили переменные
  SymbolInfoTick(_Symbol, symbTick3); // это последний тик
  int copied3 = CopyTicksRange(_Symbol, mqlTick3, COPY_TICKS_INFO, symbTick3.time_msc-20000, symbTick3.time_msc-30000); // цены между 20 секунд и 30 секунд назад
  double bid_arr3[];
  ArrayResize(bid_arr3,copied3,100000);
  double ask_arr3[];
  ArrayResize(ask_arr3,copied3,100000);
  for(int i = 0; i < copied3; i++)
  {
            bid_arr3[i] = mqlTick3[i].bid;
            ask_arr3[i] = mqlTick3[i].ask;
            bid3        = NormalizeDouble(bid_arr3[0], _Digits); // первая цена bid между 20 секунд и 30 секунд назад (аналог открытия текущего или закрытия предыдущего периода)
            ask3        = NormalizeDouble(ask_arr3[0], _Digits); // первая цена ask между 20 секунд и 30 секунд назад (аналог открытия текущего или закрытия предыдущего периода)
     int    IndMaxBid   = ArrayMaximum(bid_arr3, 0, ArraySize(bid_arr3)-1);      // Индекс элемента массива bid_arr3 с максимальной ценой
     double highestBid  = bid_arr3[IndMaxBid];                      // Самая высокая цена bid между 10 секунд и 30 секунд назад
     int    IndMinBid   = ArrayMinimum(bid_arr3, 0, ArraySize(bid_arr3)-1);      // Индекс элемента массива bid_arr3 с минимальной ценой
     double lowestBid   = bid_arr3[IndMinBid];                      // Самая низкая цена bid между 20 секунд и 30 секунд назад
     int    IndMaxAsk   = ArrayMaximum(ask_arr3, 0, ArraySize(ask_arr3)-1);      // Индекс элемента массива ask_arr3 с максимальной ценой
     double highestAsk  = ask_arr3[IndMaxAsk];                      // Самая высокая цена ask между 20 секунд и 30 секунд назад
     int    IndMinAsk   = ArrayMinimum(ask_arr3, 0, ArraySize(ask_arr3)-1);      // Индекс элемента массива ask_arr3 с минимальной ценой
     double lowestAsk   = ask_arr3[IndMinAsk];                      // Самая низкая цена ask между 20 секунд и 30 секунд назад
     double highestHigh = (highestBid+highestAsk)/2;               // Средняя наибольшего ask и наибольшего bid элемента
     double lowestLow   = (lowestBid+lowestAsk)/2;                 // Средняя наименьшего ask и наименьшего bid элемента
     if(highestHigh - (ask2 + bid2 + bid3 + ask3)/4 >= (ask2 + bid2 + bid3 + ask3)/4 - lowestLow)
     {
        VolatilitiUp3 = highestHigh - (ask2 + bid2 + bid3 + ask3)/4;
        VolatilitiLow3 = 0;
     }
     else if(highestHigh - (ask2 + bid2 + bid3 + ask3)/4 < (ask2 + bid2 + bid3 + ask3)/4 - lowestLow)
     {
        VolatilitiLow3 = (ask2 + bid2 + bid3 + ask3)/4 - lowestLow;
        VolatilitiUp3 = 0;
     }
  }
  MqlTick mqlTick4[], symbTick4; // объявили переменные
  SymbolInfoTick(_Symbol, symbTick4); // это последний тик
  int copied4 = CopyTicksRange(_Symbol, mqlTick4, COPY_TICKS_INFO, symbTick4.time_msc-30000, symbTick4.time_msc-40000); // цены между 30 секунд и 40 секунд назад
  double bid_arr4[];
  ArrayResize(bid_arr4,copied4,100000);
  double ask_arr4[];
  ArrayResize(ask_arr4,copied4,100000);
  for(int i = 0; i < copied4; i++)
  {
            bid_arr4[i] = mqlTick4[i].bid;
            ask_arr4[i] = mqlTick4[i].ask;
            bid4        = NormalizeDouble(bid_arr4[0], _Digits); // первая цена bid между 30 секунд и 40 секунд назад (аналог открытия текущего или закрытия предыдущего периода)
            ask4        = NormalizeDouble(ask_arr4[0], _Digits); // первая цена ask между 30 секунд и 40 секунд назад (аналог открытия текущего или закрытия предыдущего периода)
     int    IndMaxBid   = ArrayMaximum(bid_arr4, 0, ArraySize(bid_arr4)-1);      // Индекс элемента массива bid_arr4 с максимальной ценой
     double highestBid  = bid_arr4[IndMaxBid];                      // Самая высокая цена bid между 30 секунд и 40 секунд назад
     int    IndMinBid   = ArrayMinimum(bid_arr4, 0, ArraySize(bid_arr4)-1);      // Индекс элемента массива bid_arr4 с минимальной ценой
     double lowestBid   = bid_arr4[IndMinBid];                      // Самая низкая цена bid между 30 секунд и 40 секунд назад
     int    IndMaxAsk   = ArrayMaximum(ask_arr4, 0, ArraySize(ask_arr4)-1);      // Индекс элемента массива ask_arr4 с максимальной ценой
     double highestAsk  = ask_arr4[IndMaxAsk];                      // Самая высокая цена ask между 30 секунд и 40 секунд назад
     int    IndMinAsk   = ArrayMinimum(ask_arr4, 0, ArraySize(ask_arr4)-1);      // Индекс элемента массива ask_arr4 с минимальной ценой
     double lowestAsk   = ask_arr4[IndMinAsk];                      // Самая низкая цена ask между 30 секунд и 40 секунд назад
     double highestHigh = (highestBid+highestAsk)/2;               // Средняя наибольшего ask и наибольшего bid элемента
     double lowestLow   = (lowestBid+lowestAsk)/2;                 // Средняя наименьшего ask и наименьшего bid элемента
     if(highestHigh - (ask3 + bid3 + bid4 + ask4)/4 >= (ask3 + bid3 + bid4 + ask4)/4 - lowestLow)
     {
        VolatilitiUp4 = highestHigh - (ask3 + bid3 + bid4 + ask4)/4;
        VolatilitiLow4 = 0;
     }
     else if(highestHigh - (ask3 + bid3 + bid4 + ask4)/4 < (ask3 + bid3 + bid4 + ask4)/4 - lowestLow)
     {
        VolatilitiLow4 = (ask3 + bid3 + bid4 + ask4)/4 - lowestLow;
        VolatilitiUp4 = 0;
     }
  }
  MqlTick mqlTick5[], symbTick5; // объявили переменные
  SymbolInfoTick(_Symbol, symbTick5); // это последний тик
  int copied5 = CopyTicksRange(_Symbol, mqlTick5, COPY_TICKS_INFO, symbTick5.time_msc-40000, symbTick5.time_msc-50000); // цены между 40 секунд и 50 секунд назад
  double bid_arr5[];
  ArrayResize(bid_arr5,copied5,100000);
  double ask_arr5[];
  ArrayResize(ask_arr5,copied5,100000);
  for(int i = 0; i < copied5; i++)
  {
            bid_arr5[i] = mqlTick5[i].bid;
            ask_arr5[i] = mqlTick5[i].ask;
            bid5        = NormalizeDouble(bid_arr5[0], _Digits); // первая цена bid между 40 секунд и 50 секунд назад (аналог открытия текущего или закрытия предыдущего периода)
            ask5        = NormalizeDouble(ask_arr5[0], _Digits); // первая цена ask между 40 секунд и 50 секунд назад (аналог открытия текущего или закрытия предыдущего периода)
     int    IndMaxBid   = ArrayMaximum(bid_arr5, 0, ArraySize(bid_arr5)-1);      // Индекс элемента массива bid_arr5 с максимальной ценой
     double highestBid  = bid_arr5[IndMaxBid];                      // Самая высокая цена bid между 40 секунд и 50 секунд назад
     int    IndMinBid   = ArrayMinimum(bid_arr5, 0, ArraySize(bid_arr5)-1);      // Индекс элемента массива bid_arr5 с минимальной ценой
     double lowestBid   = bid_arr5[IndMinBid];                      // Самая низкая цена bid между 40 секунд и 50 секунд назад
     int    IndMaxAsk   = ArrayMaximum(ask_arr5, 0, ArraySize(ask_arr5)-1);      // Индекс элемента массива ask_arr5 с максимальной ценой
     double highestAsk  = ask_arr5[IndMaxAsk];                      // Самая высокая цена ask между 40 секунд и 50 секунд назад
     int    IndMinAsk   = ArrayMinimum(ask_arr5, 0, ArraySize(ask_arr5)-1);      // Индекс элемента массива ask_arr5 с минимальной ценой
     double lowestAsk   = ask_arr5[IndMinAsk];                      // Самая низкая цена ask между 40 секунд и 50 секунд назад
     double highestHigh = (highestBid+highestAsk)/2;               // Средняя наибольшего ask и наибольшего bid элемента
     double lowestLow   = (lowestBid+lowestAsk)/2;                 // Средняя наименьшего ask и наименьшего bid элемента
     if(highestHigh - (ask4 + bid4 + bid5 + ask5)/4 >= (ask4 + bid4 + bid5 + ask5)/4 - lowestLow)
     {
        VolatilitiUp5 = highestHigh - (ask4 + bid4 + bid5 + ask5)/4;
        VolatilitiLow5 = 0;
     }
     else if(highestHigh - (ask4 + bid4 + bid5 + ask5)/4 < (ask4 + bid4 + bid5 + ask5)/4 - lowestLow)
     {
        VolatilitiLow5 = (ask4 + bid4 + bid5 + ask5)/4 - lowestLow;
        VolatilitiUp5 = 0;
     }
  }
  MqlTick mqlTick6[], symbTick6; // объявили переменные
  SymbolInfoTick(_Symbol, symbTick6); // это последний тик
  int copied6 = CopyTicksRange(_Symbol, mqlTick6, COPY_TICKS_INFO, symbTick6.time_msc-40000, symbTick6.time_msc-60000); // цены между 50 секунд и 60 секунд назад
  double bid_arr6[];
  ArrayResize(bid_arr6,copied6,100000);
  double ask_arr6[];
  ArrayResize(ask_arr6,copied6,100000);
  for(int i = 0; i < copied6; i++)
  {
            bid_arr6[i] = mqlTick6[i].bid;
            ask_arr6[i] = mqlTick6[i].ask;
            bid6        = NormalizeDouble(bid_arr6[0], _Digits); // первая цена bid между 50 секунд и 60 секунд назад (аналог открытия текущего или закрытия предыдущего периода)
            ask6        = NormalizeDouble(ask_arr6[0], _Digits); // первая цена ask между 50 секунд и 60 секунд назад (аналог открытия текущего или закрытия предыдущего периода)
     int    IndMaxBid   = ArrayMaximum(bid_arr6, 0, ArraySize(bid_arr6)-1);      // Индекс элемента массива bid_arr6 с максимальной ценой
     double highestBid  = bid_arr6[IndMaxBid];                      // Самая высокая цена bid между 50 секунд и 60 секунд назад
     int    IndMinBid   = ArrayMinimum(bid_arr6, 0, ArraySize(bid_arr6)-1);      // Индекс элемента массива bid_arr6 с минимальной ценой
     double lowestBid   = bid_arr6[IndMinBid];                      // Самая низкая цена bid между 50 секунд и 60 секунд назад
     int    IndMaxAsk   = ArrayMaximum(ask_arr6, 0, ArraySize(ask_arr6)-1);      // Индекс элемента массива ask_arr6 с максимальной ценой
     double highestAsk  = ask_arr6[IndMaxAsk];                      // Самая высокая цена ask между 50 секунд и 60 секунд назад
     int    IndMinAsk   = ArrayMinimum(ask_arr6, 0, ArraySize(ask_arr6)-1);      // Индекс элемента массива ask_arr6 с минимальной ценой
     double lowestAsk   = ask_arr6[IndMinAsk];                      // Самая низкая цена ask между 50 секунд и 60 секунд назад
     double highestHigh = (highestBid+highestAsk)/2;               // Средняя наибольшего ask и наибольшего bid элемента
     double lowestLow   = (lowestBid+lowestAsk)/2;                 // Средняя наименьшего ask и наименьшего bid элемента
     if(highestHigh - (ask4 + bid4 + bid5 + ask5)/4 >= (ask4 + bid4 + bid5 + ask5)/4 - lowestLow)
     {
        VolatilitiUp6 = highestHigh - (ask4 + bid4 + bid5 + ask5)/4;
        VolatilitiLow6 = 0;
     }
     else if(highestHigh - (ask4 + bid4 + bid5 + ask5)/4 < (ask4 + bid4 + bid5 + ask5)/4 - lowestLow)
     {
        VolatilitiLow6 = (ask4 + bid4 + bid5 + ask5)/4 - lowestLow;
        VolatilitiUp6 = 0;
     }
  }
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Volatiliti=VolatilitiLow1+VolatilitiLow2+VolatilitiLow3+VolatilitiLow4+VolatilitiLow5+VolatilitiLow6;
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array1[2]={(VolatilitiLow1+VolatilitiLow2+VolatilitiLow3+VolatilitiLow4+VolatilitiLow5),VolatilitiUp6};
   int arraySize = ArraySize(Array1);
   Print("Array1 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array1[", i, "] = ", Array1[i]);
   }
   int IndMax=ArrayMaximum(Array1,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array1[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array2[3]={(VolatilitiLow1+VolatilitiLow2+VolatilitiLow3+VolatilitiLow4),VolatilitiUp5,VolatilitiLow6};
   int arraySize = ArraySize(Array2);
   Print("Array2 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array2[", i, "] = ", Array2[i]);
   }
   int IndMax=ArrayMaximum(Array2,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array2[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array3[2]={(VolatilitiLow1+VolatilitiLow2+VolatilitiLow3+VolatilitiLow4),(VolatilitiUp5+VolatilitiUp6)};
   int arraySize = ArraySize(Array3);
   Print("Array3 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array3[", i, "] = ", Array3[i]);
   }
   int IndMax=ArrayMaximum(Array3,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array3[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array4[3]={(VolatilitiLow2+VolatilitiLow2+VolatilitiLow3),VolatilitiUp4,(VolatilitiLow5+VolatilitiLow6)};
   int arraySize = ArraySize(Array4);
   Print("Array4 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array4[", i, "] = ", Array4[i]);
   }
   int IndMax=ArrayMaximum(Array4,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array4[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array5[4]={(VolatilitiLow1+VolatilitiLow2+VolatilitiLow3),VolatilitiUp4,VolatilitiLow5,VolatilitiUp6};
   int arraySize = ArraySize(Array5);
   Print("Array5 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array5[", i, "] = ", Array5[i]);
   }
   int IndMax=ArrayMaximum(Array5,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array5[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array6[3]={(VolatilitiLow1+VolatilitiLow2+VolatilitiLow3),(VolatilitiUp4+VolatilitiUp5),VolatilitiLow6};
   int arraySize = ArraySize(Array6);
   Print("Array6 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array6[", i, "] = ", Array6[i]);
   }
   int IndMax=ArrayMaximum(Array6,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array6[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array7[2]={(VolatilitiLow1+VolatilitiLow2+VolatilitiLow3),(VolatilitiUp4+VolatilitiUp5+VolatilitiUp6)};
   int arraySize = ArraySize(Array7);
   Print("Array7 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array7[", i, "] = ", Array7[i]);
   }
   int IndMax=ArrayMaximum(Array7,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array7[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array8[3]={(VolatilitiLow1+VolatilitiLow2),VolatilitiUp3,(VolatilitiLow4+VolatilitiLow5+VolatilitiLow6)};
   int arraySize = ArraySize(Array8);
   Print("Array8 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array8[", i, "] = ", Array8[i]);
   }
   int IndMax=ArrayMaximum(Array8,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array8[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array9[4]={(VolatilitiLow1+VolatilitiLow2),VolatilitiUp3,(VolatilitiLow4+VolatilitiLow5),VolatilitiUp6};
   int arraySize = ArraySize(Array9);
   Print("Array9 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array9[", i, "] = ", Array9[i]);
   }
   int IndMax=ArrayMaximum(Array9,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array9[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array10[5]={(VolatilitiLow1+VolatilitiLow2),VolatilitiUp3,VolatilitiLow4,VolatilitiUp5,VolatilitiLow6};
   int arraySize = ArraySize(Array10);
   Print("Array10 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array10[", i, "] = ", Array10[i]);
   }
   int IndMax=ArrayMaximum(Array10,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array10[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array11[4]={(VolatilitiLow1+VolatilitiLow2),VolatilitiUp3,VolatilitiLow4,(VolatilitiUp5+VolatilitiUp6)};
   int arraySize = ArraySize(Array11);
   Print("Array11 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array11[", i, "] = ", Array11[i]);
   }
   int IndMax=ArrayMaximum(Array11,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array11[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array12[3]={(VolatilitiLow1+VolatilitiLow2),(VolatilitiUp3+VolatilitiUp4),(VolatilitiLow5+VolatilitiLow6)};
   int arraySize = ArraySize(Array12);
   Print("Array12 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array12[", i, "] = ", Array12[i]);
   }
   int IndMax=ArrayMaximum(Array12,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array12[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array13[4]={(VolatilitiLow1+VolatilitiLow2),(VolatilitiUp3+VolatilitiUp4),VolatilitiLow5,VolatilitiUp6};
   int arraySize = ArraySize(Array13);
   Print("Array13 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array13[", i, "] = ", Array13[i]);
   }
   int IndMax=ArrayMaximum(Array13,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array13[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array14[3]={(VolatilitiLow1+VolatilitiLow2),(VolatilitiUp3+VolatilitiUp4+VolatilitiUp5),VolatilitiLow6};
   int arraySize = ArraySize(Array14);
   Print("Array14 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array14[", i, "] = ", Array14[i]);
   }
   int IndMax=ArrayMaximum(Array14,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array14[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array15[2]={(VolatilitiLow1+VolatilitiLow2),(VolatilitiUp3+VolatilitiUp4+VolatilitiUp5+VolatilitiUp6)};
   int arraySize = ArraySize(Array15);
   Print("Array15 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array15[", i, "] = ", Array15[i]);
   }
   int IndMax=ArrayMaximum(Array15,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array15[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array16[3]={VolatilitiLow1,VolatilitiUp2,(VolatilitiLow3+VolatilitiLow4+VolatilitiLow5+VolatilitiLow6)};
   int arraySize = ArraySize(Array16);
   Print("Array16 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array16[", i, "] = ", Array16[i]);
   }
   int IndMax=ArrayMaximum(Array16,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array16[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array17[4]={VolatilitiLow1,VolatilitiUp2,(VolatilitiLow3+VolatilitiLow4+VolatilitiLow5),VolatilitiUp6};
   int arraySize = ArraySize(Array17);
   Print("Array17 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array17[", i, "] = ", Array17[i]);
   }
   int IndMax=ArrayMaximum(Array17,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array17[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array18[5]={VolatilitiLow1,VolatilitiUp2,(VolatilitiLow3+VolatilitiLow4),VolatilitiUp5,VolatilitiLow6};
   int arraySize = ArraySize(Array18);
   Print("Array18 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array18[", i, "] = ", Array18[i]);
   }
   int IndMax=ArrayMaximum(Array18,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array18[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array19[4]={VolatilitiLow1,VolatilitiUp2,(VolatilitiLow3+VolatilitiLow4),(VolatilitiUp5+VolatilitiUp6)};
   int arraySize = ArraySize(Array19);
   Print("Array19 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array19[", i, "] = ", Array19[i]);
   }
   int IndMax=ArrayMaximum(Array19,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array19[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array20[5]={VolatilitiLow1,VolatilitiUp2,VolatilitiLow3,VolatilitiUp4,(VolatilitiLow5+VolatilitiLow6)};
   int arraySize = ArraySize(Array20);
   Print("Array20 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array20[", i, "] = ", Array20[i]);
   }
   int IndMax=ArrayMaximum(Array20,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array20[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array21[6]={VolatilitiLow1,VolatilitiUp2,VolatilitiLow3,VolatilitiUp4,VolatilitiLow5,VolatilitiUp6};
   int arraySize = ArraySize(Array21);
   Print("Array21 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array21[", i, "] = ", Array21[i]);
   }
   int IndMax=ArrayMaximum(Array21,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array21[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array22[5]={VolatilitiLow1,VolatilitiUp2,VolatilitiLow3,(VolatilitiUp4+VolatilitiUp5),VolatilitiLow6};
   int arraySize = ArraySize(Array22);
   Print("Array22 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array22[", i, "] = ", Array22[i]);
   }
   int IndMax=ArrayMaximum(Array22,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array22[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array23[4]={VolatilitiLow1,VolatilitiUp2,VolatilitiLow3,(VolatilitiUp4+VolatilitiUp5+VolatilitiUp6)};
   int arraySize = ArraySize(Array23);
   Print("Array23 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array23[", i, "] = ", Array23[i]);
   }
   int IndMax=ArrayMaximum(Array23,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array23[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array24[3]={VolatilitiLow1,(VolatilitiUp2+VolatilitiUp3),(VolatilitiLow4+VolatilitiLow5+VolatilitiLow6)};
   int arraySize = ArraySize(Array24);
   Print("Array24 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array24[", i, "] = ", Array24[i]);
   }
   int IndMax=ArrayMaximum(Array24,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array24[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array25[4]={VolatilitiLow1,(VolatilitiUp2+VolatilitiUp3),(VolatilitiLow4+VolatilitiLow5),VolatilitiUp6};
   int arraySize = ArraySize(Array25);
   Print("Array25 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array25[", i, "] = ", Array25[i]);
   }
   int IndMax=ArrayMaximum(Array25,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array25[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array26[5]={VolatilitiLow1,(VolatilitiUp2+VolatilitiUp3),VolatilitiLow4,VolatilitiUp5,VolatilitiLow6};
   int arraySize = ArraySize(Array26);
   Print("Array26 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array26[", i, "] = ", Array26[i]);
   }
   int IndMax=ArrayMaximum(Array26,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array26[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array27[4]={VolatilitiLow1,(VolatilitiUp2+VolatilitiUp3),VolatilitiLow4,(VolatilitiUp5+VolatilitiUp6)};
   int arraySize = ArraySize(Array27);
   Print("Array27 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array27[", i, "] = ", Array27[i]);
   }
   int IndMax=ArrayMaximum(Array27,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array27[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array28[3]={VolatilitiLow1,(VolatilitiUp2+VolatilitiUp3+VolatilitiUp4),(VolatilitiLow5+VolatilitiLow6)};
   int arraySize = ArraySize(Array28);
   Print("Array28 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array28[", i, "] = ", Array28[i]);
   }
   int IndMax=ArrayMaximum(Array28,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array28[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array29[4]={VolatilitiLow1,(VolatilitiUp2+VolatilitiUp3+VolatilitiUp4),VolatilitiLow5,VolatilitiUp6};
   int arraySize = ArraySize(Array29);
   Print("Array29 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array29[", i, "] = ", Array29[i]);
   }
   int IndMax=ArrayMaximum(Array29,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array29[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array30[3]={VolatilitiLow1,(VolatilitiUp2+VolatilitiUp3+VolatilitiUp4+VolatilitiUp5),VolatilitiLow6};
   int arraySize = ArraySize(Array30);
   Print("Array30 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array30[", i, "] = ", Array30[i]);
   }
   int IndMax=ArrayMaximum(Array30,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array30[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array31[2]={VolatilitiLow1,(VolatilitiUp2+VolatilitiUp3+VolatilitiUp4+VolatilitiUp5+VolatilitiUp6)};
   int arraySize = ArraySize(Array31);
   Print("Array31 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array31[", i, "] = ", Array31[i]);
   }
   int IndMax=ArrayMaximum(Array31,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array31[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array32[2]={VolatilitiUp1,(VolatilitiLow2+VolatilitiLow3+VolatilitiLow4+VolatilitiLow5+VolatilitiLow6)};
   int arraySize = ArraySize(Array32);
   Print("Array32 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array32[", i, "] = ", Array32[i]);
   }
   int IndMax=ArrayMaximum(Array32,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array32[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array33[3]={VolatilitiUp1,(VolatilitiLow2+VolatilitiLow3+VolatilitiLow4+VolatilitiLow5),VolatilitiUp6};
   int arraySize = ArraySize(Array33);
   Print("Array33 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array33[", i, "] = ", Array33[i]);
   }
   int IndMax=ArrayMaximum(Array33,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array33[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array34[4]={VolatilitiUp1,(VolatilitiLow2+VolatilitiLow3+VolatilitiLow4),VolatilitiUp5,VolatilitiLow6};
   int arraySize = ArraySize(Array34);
   Print("Array34 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array34[", i, "] = ", Array34[i]);
   }
   int IndMax=ArrayMaximum(Array34,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array34[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array35[3]={VolatilitiUp1,(VolatilitiLow2+VolatilitiLow3+VolatilitiLow4),(VolatilitiUp5+VolatilitiUp6)};
   int arraySize = ArraySize(Array35);
   Print("Array35 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array35[", i, "] = ", Array35[i]);
   }
   int IndMax=ArrayMaximum(Array35,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array35[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array36[4]={VolatilitiUp1,(VolatilitiLow2+VolatilitiLow3),VolatilitiUp4,(VolatilitiLow5+VolatilitiLow6)};
   int arraySize = ArraySize(Array36);
   Print("Array36 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array36[", i, "] = ", Array36[i]);
   }
   int IndMax=ArrayMaximum(Array36,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array36[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array37[5]={VolatilitiUp1,(VolatilitiLow2+VolatilitiLow3),VolatilitiUp4,VolatilitiLow5,VolatilitiUp6};
   int arraySize = ArraySize(Array37);
   Print("Array37 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array37[", i, "] = ", Array37[i]);
   }
   int IndMax=ArrayMaximum(Array37,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array37[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array38[4]={VolatilitiUp1,(VolatilitiLow2+VolatilitiLow3),(VolatilitiUp4+VolatilitiUp5),VolatilitiLow6};
   int arraySize = ArraySize(Array38);
   Print("Array38 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array38[", i, "] = ", Array38[i]);
   }
   int IndMax=ArrayMaximum(Array38,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array38[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array39[3]={VolatilitiUp1,(VolatilitiLow2+VolatilitiLow3),(VolatilitiUp4+VolatilitiUp5+VolatilitiUp6)};
   int arraySize = ArraySize(Array39);
   Print("Array39 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array39[", i, "] = ", Array39[i]);
   }
   int IndMax=ArrayMaximum(Array39,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array39[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array40[4]={VolatilitiUp1,VolatilitiLow2,VolatilitiUp3,(VolatilitiLow4+VolatilitiLow5+VolatilitiLow6)};
   int arraySize = ArraySize(Array40);
   Print("Array40 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array40[", i, "] = ", Array40[i]);
   }
   int IndMax=ArrayMaximum(Array40,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array40[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array41[5]={VolatilitiUp1,VolatilitiLow2,VolatilitiUp3,(VolatilitiLow4+VolatilitiLow5),VolatilitiUp6};
   int arraySize = ArraySize(Array41);
   Print("Array41 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array41[", i, "] = ", Array41[i]);
   }
   int IndMax=ArrayMaximum(Array41,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array41[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array42[6]={VolatilitiUp1,VolatilitiLow2,VolatilitiUp3,VolatilitiLow4,VolatilitiUp5,VolatilitiLow6};
   int arraySize = ArraySize(Array42);
   Print("Array42 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array42[", i, "] = ", Array42[i]);
   }
   int IndMax=ArrayMaximum(Array42,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array42[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array43[5]={VolatilitiUp1,VolatilitiLow2,VolatilitiUp3,VolatilitiLow4,(VolatilitiUp5+VolatilitiUp6)};
   int arraySize = ArraySize(Array43);
   Print("Array43 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array43[", i, "] = ", Array43[i]);
   }
   int IndMax=ArrayMaximum(Array43,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array43[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array44[4]={VolatilitiUp1,VolatilitiLow2,(VolatilitiUp3+VolatilitiUp4),(VolatilitiLow5+VolatilitiLow6)};
   int arraySize = ArraySize(Array44);
   Print("Array44 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array44[", i, "] = ", Array44[i]);
   }
   int IndMax=ArrayMaximum(Array44,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array44[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array45[5]={VolatilitiUp1,VolatilitiLow2,(VolatilitiUp3+VolatilitiUp4),VolatilitiLow5,VolatilitiUp6};
   int arraySize = ArraySize(Array45);
   Print("Array45 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array45[", i, "] = ", Array45[i]);
   }
   int IndMax=ArrayMaximum(Array45,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array45[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array46[4]={VolatilitiUp1,VolatilitiLow2,(VolatilitiUp3+VolatilitiUp4+VolatilitiUp5),VolatilitiLow6};
   int arraySize = ArraySize(Array46);
   Print("Array46 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array46[", i, "] = ", Array46[i]);
   }
   int IndMax=ArrayMaximum(Array46,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array46[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array47[3]={VolatilitiUp1,VolatilitiLow2,(VolatilitiUp3+VolatilitiUp4+VolatilitiUp5+VolatilitiUp6)};
   int arraySize = ArraySize(Array47);
   Print("Array47 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array47[", i, "] = ", Array47[i]);
   }
   int IndMax=ArrayMaximum(Array47,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array47[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array48[2]={(VolatilitiUp1+VolatilitiUp2),(VolatilitiLow3+VolatilitiLow4+VolatilitiLow5+VolatilitiLow6)};
   int arraySize = ArraySize(Array48);
   Print("Array48 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array48[", i, "] = ", Array48[i]);
   }
   int IndMax=ArrayMaximum(Array48,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array48[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array49[3]={(VolatilitiUp1+VolatilitiUp2),(VolatilitiLow3+VolatilitiLow4+VolatilitiLow5),VolatilitiUp6};
   int arraySize = ArraySize(Array49);
   Print("Array49 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array49[", i, "] = ", Array49[i]);
   }
   int IndMax=ArrayMaximum(Array49,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array49[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array50[4]={(VolatilitiUp1+VolatilitiUp2),(VolatilitiLow3+VolatilitiLow4),VolatilitiUp5,VolatilitiLow6};
   int arraySize = ArraySize(Array50);
   Print("Array50 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array50[", i, "] = ", Array50[i]);
   }
   int IndMax=ArrayMaximum(Array50,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array50[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array51[3]={(VolatilitiUp1+VolatilitiUp2),(VolatilitiLow3+VolatilitiLow4),(VolatilitiUp5+VolatilitiUp6)};
   int arraySize = ArraySize(Array51);
   Print("Array51 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array51[", i, "] = ", Array51[i]);
   }
   int IndMax=ArrayMaximum(Array51,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array51[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array52[4]={(VolatilitiUp1+VolatilitiUp2),VolatilitiLow3,VolatilitiUp4,(VolatilitiLow5+VolatilitiLow6)};
   int arraySize = ArraySize(Array52);
   Print("Array52 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array52[", i, "] = ", Array52[i]);
   }
   int IndMax=ArrayMaximum(Array52,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array52[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array53[5]={(VolatilitiUp1+VolatilitiUp2),VolatilitiLow3,VolatilitiUp4,VolatilitiLow5,VolatilitiUp6};
   int arraySize = ArraySize(Array53);
   Print("Array53 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array53[", i, "] = ", Array53[i]);
   }
   int IndMax=ArrayMaximum(Array53,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array53[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array54[4]={(VolatilitiUp1+VolatilitiUp2),VolatilitiLow3,(VolatilitiUp4+VolatilitiUp5),VolatilitiLow6};
   int arraySize = ArraySize(Array54);
   Print("Array54 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array54[", i, "] = ", Array54[i]);
   }
   int IndMax=ArrayMaximum(Array54,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array54[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array55[3]={(VolatilitiUp1+VolatilitiUp2),VolatilitiLow3,(VolatilitiUp4+VolatilitiUp5+VolatilitiUp6)};
   int arraySize = ArraySize(Array55);
   Print("Array55 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array55[", i, "] = ", Array55[i]);
   }
   int IndMax=ArrayMaximum(Array55,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array55[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array56[2]={(VolatilitiUp1+VolatilitiUp2+VolatilitiUp3),(VolatilitiLow4+VolatilitiLow5+VolatilitiLow6)};
   int arraySize = ArraySize(Array56);
   Print("Array56 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array56[", i, "] = ", Array56[i]);
   }
   int IndMax=ArrayMaximum(Array56,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array56[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array57[3]={(VolatilitiUp1+VolatilitiUp2+VolatilitiUp3),(VolatilitiLow4+VolatilitiLow5),VolatilitiUp6};
   int arraySize = ArraySize(Array57);
   Print("Array57 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array57[", i, "] = ", Array57[i]);
   }
   int IndMax=ArrayMaximum(Array57,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array57[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array58[4]={(VolatilitiUp1+VolatilitiUp2+VolatilitiUp3),VolatilitiLow4,VolatilitiUp5,VolatilitiLow6};
   int arraySize = ArraySize(Array58);
   Print("Array58 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array58[", i, "] = ", Array58[i]);
   }
   int IndMax=ArrayMaximum(Array58,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array58[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array59[3]={(VolatilitiUp1+VolatilitiUp2+VolatilitiUp3),VolatilitiLow4,(VolatilitiUp5+VolatilitiUp6)};
   int arraySize = ArraySize(Array59);
   Print("Array59 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array59[", i, "] = ", Array59[i]);
   }
   int IndMax=ArrayMaximum(Array59,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array59[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array60[2]={(VolatilitiUp1+VolatilitiUp2+VolatilitiUp3+VolatilitiUp4),(VolatilitiLow5+VolatilitiLow6)};
   int arraySize = ArraySize(Array60);
   Print("Array60 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array60[", i, "] = ", Array60[i]);
   }
   int IndMax=ArrayMaximum(Array60,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array60[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array61[3]={(VolatilitiUp1+VolatilitiUp2+VolatilitiUp3+VolatilitiUp4),VolatilitiLow5,VolatilitiUp6};
   int arraySize = ArraySize(Array61);
   Print("Array61 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array61[", i, "] = ", Array61[i]);
   }
   int IndMax=ArrayMaximum(Array61,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array61[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array62[2]={(VolatilitiUp1+VolatilitiUp2+VolatilitiUp3+VolatilitiUp4+VolatilitiUp5),VolatilitiLow6};
   int arraySize = ArraySize(Array62);
   Print("Array62 size: ", arraySize);
   for(int i = 0; i < arraySize; i++)
   {
      Print("Array62[", i, "] = ", Array62[i]);
   }
   int IndMax=ArrayMaximum(Array62,WHOLE_ARRAY,0);
   Print("IndMax= ",(string)IndMax);
   Volatiliti=Array62[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   Volatiliti=VolatilitiUp1+VolatilitiUp2+VolatilitiUp3+VolatilitiUp4+VolatilitiUp5+VolatilitiUp6;
}
  

  MqlTick mqlTick[], symbTick; // объявили переменные
  CopyTicksRange(_Symbol, mqlTick, COPY_TICKS_INFO, symbTick.time_msc, symbTick.time_msc-300); // цены за последний период
  for(int i = 0; i < ArraySize(mqlTick); i++)
  {
     double bid1 = NormalizeDouble(mqlTick[0].bid, _Digits); // первая цена bid за последний период
     double ask1 = NormalizeDouble(mqlTick[0].ask, _Digits); // первая цена ask за последний период
      if(!PositionSelect(Symbol())) // Нет открытых позиций
        {
Print("spred=",(string)spred," Volatiliti=",(string)(Volatiliti)," VolatilitiUp1=",(string)VolatilitiUp1," VolatilitiLow1=",(string)VolatilitiLow1);
            if(spred < 0)
            {
                m_trade.Buy(LotSize,Symbol(),ask0,NULL,NULL,NULL);
                m_trade.Sell(LotSize,Symbol(),bid0,NULL,NULL,NULL);
                Print("2 бай,селл, spred < 0");
            }
            if(spred >= 0 && ((spred <= VolatilitiUp1 && VolatilitiLow1 == 0) || spred < Volatiliti) && (ask0 > ask1 && bid0 > bid1))
            {
               m_trade.Buy(LotSize,Symbol(),ask0,NULL,NULL,NULL);
Print("2 бай, spred >= 0 && ((spred <= VolatilitiUp1 && VolatilitiLow1 == 0) || spred < Volatiliti) && (ask0 > ask1 && bid0 > bid1)");
            }
            if(spred >= 0 && ((spred <= VolatilitiLow1 && VolatilitiUp1 == 0) || spred < Volatiliti) && (ask0 < ask1 && bid0 < bid1))
            {
               m_trade.Sell(LotSize,Symbol(),bid0,NULL,NULL,NULL);
Print("3 селл, spred >= 0 && ((spred <= VolatilitiLow1 && VolatilitiUp1 == 0) || spred < Volatiliti) && (ask0 < ask1 && bid0 < bid1)");
            }
        }
        if(PositionSelect(Symbol())) // Есть открытые позиции
        {
            //Print("Есть открытые позиции");
            if(spred < 0 && Type == POSITION_TYPE_BUY && bid0 > Price)
            {
               Print("1 spred < 0 && Type == POSITION_TYPE_BUY && bid0 > Price");
               if(m_trade.PositionClose(m_position_ticket)) Print("1 закрыли");
            }
            if(spred < 0 && Type == POSITION_TYPE_SELL && ask0 < Price)
            {
               Print("2 spred < 0 && Type == POSITION_TYPE_SELL && ask0 < Price");
               if(m_trade.PositionClose(m_position_ticket)) Print("2 закрыли");
            }
            if(spred > 0 && Type == POSITION_TYPE_BUY && (bid0 + spred < bid1 || ask0 + spred < ask1))
            {
               Print("3 spred > 0 && Type == POSITION_TYPE_BUY && (bid0 + spred < bid1 || ask0 + spred < ask1)");
               if(m_trade.PositionClose(m_position_ticket)) Print("3 закрыли");
            }
            if(spred > 0 && Type == POSITION_TYPE_SELL && (ask0 > ask1 + spred || bid0 > bid1 + spred))
            {
               Print("4 spred > 0 && Type == POSITION_TYPE_SELL && (ask0 > ask1 + spred || bid0 > bid1 + spred)");
               if(m_trade.PositionClose(m_position_ticket)) Print("4 закрыли");
            }
        }
     }
}

//+------------------------------------------------------------------+
//| Refreshes the symbol quotes data                                 |
//+------------------------------------------------------------------+
bool RefreshRates(void)
  {
   if(!m_symbol.RefreshRates())
     {
      Print("RefreshRates error");
      return(false);
     }
//--- protection against the return value of "zero"
   if(m_symbol.Ask()==0 || m_symbol.Bid()==0)
      return(false);
//---
   return(true);
  }

//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
   EventKillTimer();
}
